import org.uddi4j.client.UDDIProxy;
import org.uddi4j.response.BusinessInfo;
import org.uddi4j.response.BusinessInfos;
import org.uddi4j.response.BusinessList;
import org.uddi4j.transport.TransportFactory;
import org.uddi4j.util.CategoryBag;
import org.uddi4j.util.FindQualifier;
import org.uddi4j.util.FindQualifiers;
import org.uddi4j.util.KeyedReference;
import java.util.Vector;

public class UDDIFindBusiness10 {

	public static void main(String[] args) throws Exception {

		System.setProperty(TransportFactory.PROPERTY_NAME, "org.uddi4j.transport.ApacheAxisTransport");

		UDDIProxy proxy = new UDDIProxy();
		proxy.setInquiryURL("http://uddi.microsoft.com/inquire");

		Vector cbv = new Vector();
		KeyedReference kr = new KeyedReference("Document management software", "43161801");
	 	kr.setTModelKey("uuid:DB77450D-9FA8-45D4-A7BC-04411D14E384");
		cbv.addElement(kr);
		CategoryBag cb = new CategoryBag();
		cb.setKeyedReferenceVector(cbv);

		Vector fqv = new Vector();
		FindQualifier fq = new FindQualifier(FindQualifier.sortByNameDesc);
		fqv.add(fq);
		FindQualifiers fqs = new FindQualifiers();
		fqs.setFindQualifierVector(fqv);

		BusinessList bl = proxy.find_business(null, null, null, cb, null, fqs, 0);

		BusinessInfos bis = bl.getBusinessInfos();
		if (bis.size() == 0) {
			System.out.println("no business(es) found");
			System.exit(0);
		}

		System.out.println(bis.size()+" business(es) found\n");
		Vector biv = bis.getBusinessInfoVector();
		for (int i = 0; i < biv.size(); i++) {
			BusinessInfo bi = (BusinessInfo)biv.elementAt(i);
			System.out.println(bi.getNameString());
			System.out.println(bi.getBusinessKey());
			System.out.println("\n");
		}
	}
}